/* Sol. 10 Luglio traccia A*/

#include <windows.h>
#include <stdio.h>
#include <stdlib.h> 


#define NCLIENTI 200
#define NVENDITORI 5

#define MAX_SLEEP_TIME 5000 /* attesa massima prima di cercare di comprare il biglietto */

int nbiglietti=100;

HANDLE venditori, mutex_biglietti; /* i semafori condivisi */
 

void cliente (int num)
{
	int attesa;
    
	attesa = rand()%MAX_SLEEP_TIME;
	Sleep (attesa);
	printf (" Il cliente n. %d vuole comprare il biglietto\n", num);
	WaitForSingleObject(venditori,INFINITE);
	WaitForSingleObject(mutex_biglietti,INFINITE);
	if (nbiglietti>0)
		{
			nbiglietti--;
			printf ("il cliente num. %d compra ilbiglietto (%d biglietti rimasti)\n",num,nbiglietti);
		}
		else
			printf ("il cliente num. %d se ne va perche' non ci sono piu' biglietti\n",num);
		ReleaseSemaphore(venditori,1,NULL);
	    ReleaseSemaphore(mutex_biglietti,1,NULL);
}

int main(int arg,char *argv[]) {    	
	
	int i;
	HANDLE clienti[NCLIENTI];
    DWORD clienteID[NCLIENTI];
	/* inizializza i semafori */
    mutex_biglietti = CreateSemaphore (NULL,1,1,NULL);
	venditori = CreateSemaphore (NULL,NVENDITORI,NVENDITORI,NULL);
	


	/* inizializza ed esegue i thread clienti*/
    for (i=0;i<NCLIENTI;i++)
	   clienti[i]=CreateThread(NULL, 1000, (LPTHREAD_START_ROUTINE) cliente, (LPVOID) (i+1), 0, &clienteID[i]);    
  
   for (i=0;i<NCLIENTI;i++)
   {
	   CloseHandle(clienti[i]);
	}
   	
   ExitThread(1); 

    return 0;
}

