/* Sol. 10 Luglio traccia A*/

#include <windows.h>
#include <stdio.h>
#include <stdlib.h> 


#define NUBRIACONI 20
#define NRUBINETTI 3

#define MAX_SLEEP_TIME 5000 /* attesa massima prima di bere */

int tot_litri=100;

HANDLE rubinetti, mutex_litri; /* i semafori condivisi */
 

void ubriacone (int num)
{
	int attesa;
    int ancora_vino=1;

	while (ancora_vino)
	{
		attesa = rand()%MAX_SLEEP_TIME;
		Sleep (attesa);
		printf (" Il bevitore n. %d vuole bere\n", num);
		WaitForSingleObject(rubinetti,INFINITE);
		WaitForSingleObject(mutex_litri,INFINITE);
		if (tot_litri>0)
		{
			tot_litri--;
			printf ("il bevitore num. %d beve 1 litro (%d litri rimasti)\n",num,tot_litri);
		}
		else
		{
			printf ("il bevitore num. %d se ne va perche' il vino e' finito\n",num);
			ancora_vino=0;
		}
		ReleaseSemaphore(mutex_litri,1,NULL);
	    ReleaseSemaphore(rubinetti,1,NULL);
	} // fine while
}

int main(int arg,char *argv[]) {    	
	
	int i;
	HANDLE bevitori[NUBRIACONI];
    DWORD beviID[NUBRIACONI];
	/* inizializza i semafori */
    mutex_litri = CreateSemaphore (NULL,1,1,NULL);
	rubinetti = CreateSemaphore (NULL,NRUBINETTI,NRUBINETTI,NULL);
	


	/* inizializza ed esegue i thread bevitori*/
    for (i=0;i<NUBRIACONI;i++)
	   bevitori[i]=CreateThread(NULL, 1000, (LPTHREAD_START_ROUTINE) ubriacone, (LPVOID) (i+1), 0, &beviID[i]);    
  
   for (i=0;i<NUBRIACONI;i++)
   {
	   CloseHandle(bevitori[i]);
	}
   	
   ExitThread(1); 

    return 0;
}

